

/**
 *  Generated by mxmlc 4.0
 *
 *  Package:    net.systemeD.potlatch2.dialogs
 *  Class:      TasksDialog
 *  Source:     /Users/richard/OpenStreetMap/potlatch2/net/systemeD/potlatch2/dialogs/TasksDialog.mxml
 *  Template:   flex2/compiler/mxml/gen/ClassDef.vm
 *  Time:       2020.05.08 21:01:45 BST
 */

package net.systemeD.potlatch2.dialogs
{

import flash.accessibility.*;
import flash.debugger.*;
import flash.display.*;
import flash.errors.*;
import flash.events.*;
import flash.events.MouseEvent;
import flash.external.*;
import flash.geom.*;
import flash.media.*;
import flash.net.*;
import flash.printing.*;
import flash.profiler.*;
import flash.system.*;
import flash.text.*;
import flash.ui.*;
import flash.utils.*;
import flash.xml.*;
import mx.binding.*;
import mx.controls.Spacer;
import mx.core.ClassFactory;
import mx.core.DeferredInstanceFromClass;
import mx.core.DeferredInstanceFromFunction;
import mx.core.IDeferredInstance;
import mx.core.IFactory;
import mx.core.IFlexModuleFactory;
import mx.core.IPropertyChangeNotifier;
import mx.core.mx_internal;
import mx.filters.*;
import mx.styles.*;
import spark.components.Button;
import spark.components.Label;
import spark.components.TextInput;
import spark.components.TitleWindow;
import spark.layouts.VerticalLayout;



//  begin class def
public class TasksDialog
    extends spark.components.TitleWindow
{

    //  instance variables
    [Bindable]
	/**
 * @private
 **/
    public var src : spark.components.TextInput;


    //  type-import dummies



    //  constructor (Flex display object)
    /**
     * @private
     **/
    public function TasksDialog()
    {
        super();

        mx_internal::_document = this;




        // layer initializers

       
        // properties
        this.title = "Load tasks file";
        this.width = 350;
        this.height = 120;
        this.layout = _TasksDialog_VerticalLayout1_c();
        this.controlBarContent = [_TasksDialog_Button1_c(), _TasksDialog_Spacer1_c(), _TasksDialog_Button2_c(), _TasksDialog_Button3_c()];
        this.mxmlContentFactory = new mx.core.DeferredInstanceFromFunction(_TasksDialog_Array2_c);


        // events












    }

    /**
     * @private
     **/ 
    private var __moduleFactoryInitialized:Boolean = false;

    /**
     * @private
     * Override the module factory so we can defer setting style declarations
     * until a module factory is set. Without the correct module factory set
     * the style declaration will end up in the wrong style manager.
     **/ 
    override public function set moduleFactory(factory:IFlexModuleFactory):void
    {
        super.moduleFactory = factory;
        
        if (__moduleFactoryInitialized)
            return;

        __moduleFactoryInitialized = true;


        // our style settings



                         
    }
 
    //  initialize()
    /**
     * @private
     **/
    override public function initialize():void
    {


        super.initialize();
    }


    //  scripts
    //  <Script>, line 25 - 133

    import mx.managers.PopUpManager;
    import mx.events.CloseEvent;
    import mx.core.Application;
    import mx.core.FlexGlobals;
    import net.systemeD.halcyon.Globals;
    import net.systemeD.halcyon.Map;
    import net.systemeD.halcyon.AttentionEvent;
    import net.systemeD.halcyon.connection.Connection;
	import net.systemeD.potlatch2.EditController;
	import net.systemeD.potlatch2.TasksPalette;
    import com.adobe.serialization.json.JSON;
	import flash.events.*;
	import flash.net.*;

	private var palette:TasksPalette;
	private var controller:EditController;
	private var localFileReference:FileReference;

	public function init(_controller:EditController):void {
		controller=_controller;
		PopUpManager.addPopUp(this, Application(FlexGlobals.topLevelApplication), true);
		PopUpManager.centerPopUp(this);
		this.addEventListener(CloseEvent.CLOSE, tasksDialog_close);
	}

    private function tasksDialog_close(evt:CloseEvent):void {
        PopUpManager.removePopUp(this);
    }

	private function loadTasksRemote():void {
        PopUpManager.removePopUp(this);
		var loader:URLLoader = new URLLoader();
		loader.addEventListener(Event.COMPLETE, fileLoaded);
		loader.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
		loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
		loader.load(new URLRequest(src.text));
	}

	private function loadTasksFile():void {
		localFileReference=new FileReference(); 
		var fileTypes:String="*.json;*.geojson;*.gpx";
		localFileReference.browse([new FileFilter(fileTypes,fileTypes)]); 
		localFileReference.addEventListener(Event.SELECT, selectFileLocal);
	}
	private function selectFileLocal(event:Event):void {
        PopUpManager.removePopUp(this);
		localFileReference.addEventListener(Event.COMPLETE, fileLoaded);
		localFileReference.addEventListener(IOErrorEvent.IO_ERROR,ioErrorHandler);
		localFileReference.addEventListener(SecurityErrorEvent.SECURITY_ERROR,securityErrorHandler);
		localFileReference.load();
	}
	private function fileLoaded(e:Event):void {
		openPalette();
		palette.resetTasks();
		var result:String=e.target.data;
		if (result.substr(0,5)=='<?xml') { parseFromGPX(result); }
									else { parseFromGeoJSON(result); }
		if (palette.hasTasks()) {
			palette.updateText();
		} else {
			closePalette();
			controller.dispatchEvent(new AttentionEvent(AttentionEvent.ALERT, null, "No points found in the input file"));
		}
	}
	private function parseFromGPX(str:String):void {
		var file:XML = new XML(str);
		for each (var ns:Namespace in file.namespaceDeclarations()) {
			if (ns.uri.match(/^http:\/\/www\.topografix\.com\/GPX\/1\/[01]$/)) {
				default xml namespace = ns;
			}
		}
		for each (var wpt:XML in file.wpt) {
			palette.addTask({ lat: wpt.@lat, lon: wpt.@lon, text: wpt.desc || wpt.cmt || wpt.sym })
		}
		default xml namespace = new Namespace("");
	}
	private function parseFromGeoJSON(str:String):void {
		var file:Object = com.adobe.serialization.json.JSON.decode(str);
		for each (var feature:Object in file.features) {
			if (feature.geometry.type=='Point') {
				var text:String = null;
				if (feature.properties) { text = feature.properties.name || getFirstProperty(feature.properties); }
				palette.addTask({ lat: feature.geometry.coordinates[1], lon: feature.geometry.coordinates[0], text: text });
			}
		}
	}
	private function getFirstProperty(obj:Object):String { for (var k:String in obj) { return obj[k]; } return null; }

	private function openPalette():void {
		if (palette) {
			palette.visible=true;
		} else {
			palette=TasksPalette(PopUpManager.createPopUp(Globals.vars.root,TasksPalette,false));
			palette.init(controller);
			palette.x=FlexGlobals.topLevelApplication.suggestTasksPaletteX();
			palette.y=FlexGlobals.topLevelApplication.suggestTasksPaletteY();
		}
	}
	private function closePalette():void { palette.visible=false; }

	protected function securityErrorHandler(event:SecurityErrorEvent):void {
		controller.dispatchEvent(new AttentionEvent(AttentionEvent.ALERT, null, "Couldn't open the file (security error)"));
	}
	protected function ioErrorHandler(event:IOErrorEvent):void { 
		controller.dispatchEvent(new AttentionEvent(AttentionEvent.ALERT, null, "Couldn't open the file (IO error)"));
	}

    

    //  end scripts


    //  supporting function definitions for properties, events, styles, effects
private function _TasksDialog_VerticalLayout1_c() : spark.layouts.VerticalLayout
{
	var temp : spark.layouts.VerticalLayout = new spark.layouts.VerticalLayout();
	temp.paddingLeft = 5;
	temp.paddingRight = 5;
	temp.paddingTop = 5;
	temp.paddingBottom = 5;
	return temp;
}

private function _TasksDialog_Button1_c() : spark.components.Button
{
	var temp : spark.components.Button = new spark.components.Button();
	temp.label = "Open file...";
	temp.styleName = "titleWindowButton";
	temp.addEventListener("click", ___TasksDialog_Button1_click);
	if (!temp.document) temp.document = this;
	return temp;
}

/**
 * @private
 **/
public function ___TasksDialog_Button1_click(event:flash.events.MouseEvent):void
{
	loadTasksFile()
}

private function _TasksDialog_Spacer1_c() : mx.controls.Spacer
{
	var temp : mx.controls.Spacer = new mx.controls.Spacer();
	temp.percentWidth = 100.0;
	if (!temp.document) temp.document = this;
	return temp;
}

private function _TasksDialog_Button2_c() : spark.components.Button
{
	var temp : spark.components.Button = new spark.components.Button();
	temp.label = "Cancel";
	temp.styleName = "titleWindowButton";
	temp.addEventListener("click", ___TasksDialog_Button2_click);
	if (!temp.document) temp.document = this;
	return temp;
}

/**
 * @private
 **/
public function ___TasksDialog_Button2_click(event:flash.events.MouseEvent):void
{
	PopUpManager.removePopUp(this);
}

private function _TasksDialog_Button3_c() : spark.components.Button
{
	var temp : spark.components.Button = new spark.components.Button();
	temp.label = "Fetch URL";
	temp.styleName = "titleWindowButton";
	temp.addEventListener("click", ___TasksDialog_Button3_click);
	if (!temp.document) temp.document = this;
	return temp;
}

/**
 * @private
 **/
public function ___TasksDialog_Button3_click(event:flash.events.MouseEvent):void
{
	loadTasksRemote()
}

private function _TasksDialog_Array2_c() : Array
{
	var temp : Array = [_TasksDialog_Label1_c(), _TasksDialog_TextInput1_i()];
	return temp;
}

private function _TasksDialog_Label1_c() : spark.components.Label
{
	var temp : spark.components.Label = new spark.components.Label();
	temp.text = "Enter the URL of a GPX or GeoJSON file containing a series of points.";
	if (!temp.document) temp.document = this;
	return temp;
}

private function _TasksDialog_TextInput1_i() : spark.components.TextInput
{
	var temp : spark.components.TextInput = new spark.components.TextInput();
	temp.text = "";
	temp.percentWidth = 100.0;
	temp.id = "src";
	if (!temp.document) temp.document = this;
	src = temp;
	mx.binding.BindingManager.executeBindings(this, "src", src);
	return temp;
}





    //  embed carrier vars
    //  end embed carrier vars


//  end class def
}

//  end package def
}
